package common.caching.test;

import java.util.*;
import java.io.*;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.extensions.ActiveTestSuite;

import common.logging.WebPortalLogger;
import common.caching.CachingException;
import common.caching.*;


/**
 * JUnit test case to test the caching methods defined in CachingManager interface.
 *
 * @version 1.0
 * @author Srini Penchikala
 * @since 10/03/2003
 */
public class CachingTestCaseOSCache extends CachingTestCase {

  /**
   * Attributes
   */

   /**
    * Constructor for the CachingTestCase object.
    */
   public CachingTestCaseOSCache(String name) {
      super(name);
   }

   /**
    * A unit test suite for JUnit
    *
    * @return    The test suite
    */
   public static Test suite() {
      TestSuite testSuite = null;
      testSuite = new ActiveTestSuite();
      testSuite.addTest(new CachingTestCaseOSCache("runTests"));

      return testSuite;
   }

   /**
    * Test setup
    */
   protected void setUp() {
      try {
         WebPortalLogger.info("Getting CacheManager instance.");
         manager = (BaseCacheManagerOSCache)BaseCacheManagerOSCache.getInstance();
         WebPortalLogger.info("CacheManager : " + manager.toString());
      } catch (Exception e) {
         // Exception handling here.
      }
   }

	/**
	 * Main method passes this test to the text test runner.
	 */
	public static void main(String args[]) {
		// Run the tests
		junit.textui.TestRunner.run(suite());
	}

}
// End of CachingTestCase.java
