package common.caching.util;

import java.util.Timer;
import java.util.Calendar;
import java.util.Date;
import java.util.Properties;

import common.caching.CachingException;
import common.caching.ICacheManager;
import common.caching.BaseCacheManagerJCS;


/**
 * Class CacheTimer
 *
 */
public class CacheTimer {

	private static final long DELAY = 0;
	private static final long PERIOD = 0;
	private Timer timer  = new Timer(true);
	private static CacheTimer cacheTimer = null;

	private static ICacheManager manager;
//	private static String memoryCacheRegion = "scheduledExpireCache";

	private String cacheProperties = "cache.ccf";

	/**
	 * Constructor CacheTimer
	 */
	private CacheTimer() {
		System.out.println("Getting CacheManager instance.");
      manager = (BaseCacheManagerJCS)BaseCacheManagerJCS.getInstance();
	}

	/**
	 * Method getCacheTimer
	 */
	public static synchronized CacheTimer getCacheTimer() {
		if (cacheTimer == null) {
			cacheTimer = new CacheTimer();
		}
		return cacheTimer;
	}

	/**
	 * Method scheduleCacheExpire
	 */
	public void scheduleCacheExpire(ICacheManager cache, String regionName) throws CachingException {
		//LOG.debug("scheduleCacheRemoval( " + cache + " )");

		System.out.println("scheduleCacheExpire( " + cache + " : " + regionName + " )");

      //////////////////////////////////////////
      Properties props = new Properties();
      try {
         java.net.URL url = ClassLoader.getSystemResource(cacheProperties);
         props.load(url.openStream());
//         props.list(System.out);
      } catch (Exception e) {
         throw new CachingException(e);
      }

      String cachePrefix = "jcs.region." + regionName + ".elementattributes.";

//      int dayOfWeek = new Integer(props.getProperty(cachePrefix + "DAY_OF_WEEK")).intValue();
      int dayOfWeek = 0;
      String DOW = props.getProperty(cachePrefix + "DAY_OF_WEEK");
      int hourOfDay = new Integer(props.getProperty(cachePrefix + "HOUR_OF_DAY")).intValue();
      int minute = new Integer(props.getProperty(cachePrefix + "MINUTE")).intValue();
      int second = new Integer(props.getProperty(cachePrefix + "SECOND")).intValue();
      long delay = new Long(props.getProperty(cachePrefix + "DELAY")).longValue();

      Calendar calendar = Calendar.getInstance();
      int dow = calendar.get(Calendar.DAY_OF_WEEK);
      String weekDay = new Integer(dow).toString();
      if (DOW.indexOf(weekDay) != -1) dayOfWeek = dow;

      // Now set the day and time in the calendar object
      calendar.set(Calendar.DAY_OF_WEEK, dayOfWeek);
      calendar.set(Calendar.HOUR_OF_DAY, hourOfDay);
      calendar.set(Calendar.MINUTE, minute);
      calendar.set(Calendar.SECOND, second);

//		Calendar calendar = Calendar.getInstance();
//      calendar.set(Calendar.DAY_OF_WEEK, dayOfWeek);
//      calendar.set(Calendar.HOUR_OF_DAY, hourOfDay);
//      calendar.set(Calendar.MINUTE, minute);
//      calendar.set(Calendar.SECOND, second);

		Date time = calendar.getTime();
		//////////////////////////////////////////

		//CacheTimerTask task = new CacheTimerTask(cache);
		CacheTimerTask task = new CacheTimerTask(manager, regionName);
		timer.scheduleAtFixedRate(task, time, delay);
	}
}
// End of CacheTimer.java
