package common.caching.util;

import java.util.TimerTask;
import java.util.Date;

//import common.exception.CachingException;
import common.caching.ICacheManager;
import common.caching.BaseCacheManager;

/**
 * Class CacheTimerTask
 *
 */
public class CacheTimerTask extends TimerTask {

	private static long         instanceCounter = 0;
	private static final long   instanceNumber  = (instanceCounter++);
	private ICacheManager cacheManager = null;
   private String regionName = "";

	/**
	 * Constructor CacheTimerTask
	 *
	 * @param cacheManager
	 */
	public CacheTimerTask(ICacheManager cacheManager, String regionName) {
		//LOG.debug("new CacheTimerTask( " + cache + " )");
		System.out.println("new CacheTimerTask( " + cacheManager + " )");
		this.cacheManager = cacheManager;
      this.regionName = regionName;
	}

	/**
	 * Method run
	 */
	public void run() {

		String threadName = Thread.currentThread().getName();
		Thread.currentThread().setName("Timer for " + instanceNumber);

		synchronized (cacheManager) {
         try {
            Date dt = new Date();
				System.out.println("Calling runCacheExpireSchedule() @ " + dt.toString());
				System.out.println("cache : " + cacheManager);
//				((BaseCacheManager)cacheManager).runCacheExpireSchedule(regionName);
				System.out.println("runCacheExpireSchedule() completed successfully.");
         } catch (Exception e) {
            // Exception handling here.
         }
		}

		Thread.currentThread().setName(threadName);
	}
}
// End of CacheTimerTask.java
